with Ada.Float_Text_IO;
with Ada.Text_IO;
with Ada_BLAS.Real;

procedure Example1 is
   
   type Vector is array (Positive range <>) of Float;
   pragma Convention (Fortran, Vector); -- May not be necessary
   
   A : Vector (1 .. 2) := (1.0, 1.0);
   B : Vector (1 .. 2) := (1.0, -1.0);
   
   type Matrix is array (Positive range <>, Positive range <>) of Float;
   pragma Convention (Fortran, Matrix); -- Necessary
   
   package Real_BLAS is new Ada_BLAS.Real (
        Float_Type  => Float,
        Index_Type  => Positive,
        Vector_Type => Vector,
        Matrix_Type => Matrix
      );

   D : Float := Real_BLAS.DOT (A, B); -- Does your compiler eliminate all overhead?
begin
   Ada.Text_IO.Put ("Dot product is: ");
   Ada.Float_Text_IO.Put (D);
   Ada.Text_IO.New_Line;
   Ada.Text_IO.Flush;
end Example1;
